﻿import caurina.transitions.Tweener;//import tween class
class com.rubenbristian.ColorTween {
	public function ColorTween(target:MovieClip, startColor:Number, endColor:Number, time:Number) {
		var colorObj1:Object = hexToRGB(startColor);//get the red, blue and green values for the start color
		var colorObj2:Object = hexToRGB(endColor);//get the red, blue and green values for the end color
		target._red = colorObj1.red;//create the red color variable of the targeted movieclip
		target._green = colorObj1.green;//create the green color variable of the targeted movieclip
		target._blue = colorObj1.blue;//create the blue color variable of the targeted movieclipt
		target._easing = 0;
		Tweener.addTween(target,{_red:colorObj2.red, _green:colorObj2.green, _blue:colorObj2.blue, time:time});//increase/decrease the red,green,blue values of the starting color to reach the red,blue,green values of the desired ending color
		var changeColorI:Number = setInterval(changeColor, 1);//interval that repeats changeColor() function every 1ms
		function changeColor() {
			var newColor:Color = new Color(target);//create a new color object that controls the color of the targeted movieclip
			newColor.setRGB(target._red << 16 ^ target._green << 8 ^ target._blue);//modify if's color after the current color
			if (target._red == colorObj2.red && target._green == colorObj2.green && target._blue == colorObj2.blue) {//if the values of the current color reached the values of the final color, clear this interval
				clearInterval(changeColorI);
			}
		}
	}
	//function that converts from hex to rgb. returns a object with "red", "green", "blue" properties
	public function hexToRGB(hex:Number) {
		var returnObj:Object = new Object();
		returnObj.red = hex >> 16;
		var temp = hex ^ returnObj.red << 16;
		returnObj.green = temp >> 8;
		returnObj.blue = temp ^ returnObj.green << 8;
		return returnObj;
	}
	//function that converts from rgb to hex
	public function RGBToHex(red:Number, green:Number, blue:Number) {
		return red << 16 ^ green << 8 ^ blue;
	}
}